import idaapi
idaapi.CompileLine(r"""
static renesas_sh_substr(ostr,osubstr) {
	if (strstr(ostr,osubstr) != BADADDR) ostr = substr(ostr,0,strstr(ostr,osubstr)) + substr(ostr,strstr(ostr,osubstr) + strlen(osubstr),-1);
	return ostr;
}
static renesas_sh_decode_displ(opnd,opndbin,R0,R1,R2,R3,R4,R5,R6,R7,R8,R9,R10,R11,R12,R13,R14,R15,GBR,VBR,SR) {
	auto index=0,base=0;
	opnd = renesas_sh_substr(opnd,"@");
	opnd = renesas_sh_substr(opnd,"(");
	opnd = renesas_sh_substr(opnd,")");
	opnd = renesas_sh_substr(opnd,",");
	if	(strstr(opnd,"r15") != BADADDR) { index = R15; opnd = renesas_sh_substr(opnd,"r15"); }
	else if (strstr(opnd,"r14") != BADADDR) { index = R14; opnd = renesas_sh_substr(opnd,"r14"); }
	else if (strstr(opnd,"r13") != BADADDR) { index = R13; opnd = renesas_sh_substr(opnd,"r13"); }
	else if (strstr(opnd,"r12") != BADADDR) { index = R12; opnd = renesas_sh_substr(opnd,"r12"); }
	else if (strstr(opnd,"r11") != BADADDR) { index = R11; opnd = renesas_sh_substr(opnd,"r11"); }
	else if (strstr(opnd,"r10") != BADADDR) { index = R10; opnd = renesas_sh_substr(opnd,"r10"); }
	else if (strstr(opnd,"r9") != BADADDR) { index = R9; opnd = renesas_sh_substr(opnd,"r9"); }
	else if (strstr(opnd,"r8") != BADADDR) { index = R8; opnd = renesas_sh_substr(opnd,"r8"); }
	else if (strstr(opnd,"r7") != BADADDR) { index = R7; opnd = renesas_sh_substr(opnd,"r7"); }
	else if (strstr(opnd,"r6") != BADADDR) { index = R6; opnd = renesas_sh_substr(opnd,"r6"); }
	else if (strstr(opnd,"r5") != BADADDR) { index = R5; opnd = renesas_sh_substr(opnd,"r5"); } 
	else if (strstr(opnd,"r4") != BADADDR) { index = R4; opnd = renesas_sh_substr(opnd,"r4"); }
	else if (strstr(opnd,"r3") != BADADDR) { index = R3; opnd = renesas_sh_substr(opnd,"r3"); } 
	else if (strstr(opnd,"r2") != BADADDR) { index = R2; opnd = renesas_sh_substr(opnd,"r2"); }
	else if (strstr(opnd,"r1") != BADADDR) { index = R1; opnd = renesas_sh_substr(opnd,"r1"); }
	else if (strstr(opnd,"r0") != BADADDR) { index = R0; opnd = renesas_sh_substr(opnd,"r0"); }
	else if (strstr(opnd,"gbr") != BADADDR) { index = GBR; opnd = renesas_sh_substr(opnd,"gbr"); }
	else if (strstr(opnd,"vbr") != BADADDR) { index = VBR; opnd = renesas_sh_substr(opnd,"vbr"); }
	else if (strstr(opnd,"sr") != BADADDR) { index = SR; opnd = renesas_sh_substr(opnd,"sr"); }
	if (opnd == "" || index == BADADDR) return index;
	else {		
		if	(strstr(opnd,"r15") != BADADDR) { base = R15; opnd = renesas_sh_substr(opnd,"r15"); }
		else if (strstr(opnd,"r14") != BADADDR) { base = R14; opnd = renesas_sh_substr(opnd,"r14"); }
		else if (strstr(opnd,"r13") != BADADDR) { base = R13; opnd = renesas_sh_substr(opnd,"r13"); }
		else if (strstr(opnd,"r12") != BADADDR) { base = R12; opnd = renesas_sh_substr(opnd,"r12"); }
		else if (strstr(opnd,"r11") != BADADDR) { base = R11; opnd = renesas_sh_substr(opnd,"r11"); }
		else if (strstr(opnd,"r10") != BADADDR) { base = R10; opnd = renesas_sh_substr(opnd,"r10"); }
		else if (strstr(opnd,"r9") != BADADDR) { base = R9; opnd = renesas_sh_substr(opnd,"r9"); }
		else if (strstr(opnd,"r8") != BADADDR) { base = R8; opnd = renesas_sh_substr(opnd,"r8"); }
		else if (strstr(opnd,"r7") != BADADDR) { base = R7; opnd = renesas_sh_substr(opnd,"r7"); }
		else if (strstr(opnd,"r6") != BADADDR) { base = R6; opnd = renesas_sh_substr(opnd,"r6"); }
		else if (strstr(opnd,"r5") != BADADDR) { base = R5; opnd = renesas_sh_substr(opnd,"r5"); } 
		else if (strstr(opnd,"r4") != BADADDR) { base = R4; opnd = renesas_sh_substr(opnd,"r4"); }
		else if (strstr(opnd,"r3") != BADADDR) { base = R3; opnd = renesas_sh_substr(opnd,"r3"); } 
		else if (strstr(opnd,"r2") != BADADDR) { base = R2; opnd = renesas_sh_substr(opnd,"r2"); }
		else if (strstr(opnd,"r1") != BADADDR) { base = R1; opnd = renesas_sh_substr(opnd,"r1"); }
		else if (strstr(opnd,"r0") != BADADDR) { base = R0; opnd = renesas_sh_substr(opnd,"r0"); }
		else if (strstr(opnd,"gbr") != BADADDR) { base = GBR; opnd = renesas_sh_substr(opnd,"gbr"); }
		else if (strstr(opnd,"vbr") != BADADDR) { base = VBR; opnd = renesas_sh_substr(opnd,"vbr"); }
		else if (strstr(opnd,"sr") != BADADDR) { base = SR; opnd = renesas_sh_substr(opnd,"sr"); }
		if (base == BADADDR) return base;
		else {
			if (opnd == "") return index + base;
			else return index + base + opndbin;
		}
	}
}
static renesas_sh_dynamic_xrefs(void) {

	//119C
	//9A3EA
	//11E436
	//176D88
	//E760
	//DA64
	//DB78
	//1680FC
	//16F068
	//2DAE

	auto modified,pos,mnem,jdst,ddst,opnd,dbg;
	auto R0=BADADDR,R1=BADADDR,R2=BADADDR,R3=BADADDR,R4=BADADDR,R5=BADADDR,R6=BADADDR,R7=BADADDR,R8=BADADDR,R9=BADADDR,R10=BADADDR,R11=BADADDR,R12=BADADDR,R13=BADADDR,R14=BADADDR,R15=BADADDR,GBR=BADADDR,VBR=BADADDR,SR=BADADDR;
	do {
		modified = 0;
		for (pos = 0;pos != BADADDR;pos = FindCode(pos,0x01)) {
			mnem = GetMnem(pos);
			if (mnem == "mov" || mnem == "movu.b" || mnem == "movu.w" || mnem == "movu.l" || mnem == "mov.l" || mnem == "mov.w" || mnem == "mov.b" || mnem == "movi20" || mnem == "movi20s" || mnem == "ldc" || mnem == "stc") {
				if (GetOpType(pos,0) == o_imm && GetOpType(pos,1) == o_reg) {
					if	(GetOpnd(pos,1) == "r0") R0 = GetOperandValue(pos,0);
					else if (GetOpnd(pos,1) == "r1") R1 = GetOperandValue(pos,0);
					else if (GetOpnd(pos,1) == "r2") R2 = GetOperandValue(pos,0);
					else if (GetOpnd(pos,1) == "r3") R3 = GetOperandValue(pos,0);
					else if (GetOpnd(pos,1) == "r4") R4 = GetOperandValue(pos,0);
					else if (GetOpnd(pos,1) == "r5") R5 = GetOperandValue(pos,0);
					else if (GetOpnd(pos,1) == "r6") R6 = GetOperandValue(pos,0);
					else if (GetOpnd(pos,1) == "r7") R7 = GetOperandValue(pos,0);
					else if (GetOpnd(pos,1) == "r8") R8 = GetOperandValue(pos,0);
					else if (GetOpnd(pos,1) == "r9") R9 = GetOperandValue(pos,0);
					else if (GetOpnd(pos,1) == "r10") R10 = GetOperandValue(pos,0);
					else if (GetOpnd(pos,1) == "r11") R11 = GetOperandValue(pos,0);
					else if (GetOpnd(pos,1) == "r12") R12 = GetOperandValue(pos,0);
					else if (GetOpnd(pos,1) == "r13") R13 = GetOperandValue(pos,0);
					else if (GetOpnd(pos,1) == "r14") R14 = GetOperandValue(pos,0);
					else if (GetOpnd(pos,1) == "r15") R15 = GetOperandValue(pos,0);

				} else if (GetOpType(pos,0) == o_reg && (GetOpType(pos,1) == o_displ || GetOpType(pos,1) == o_phrase)) {
					ddst = renesas_sh_decode_displ(GetOpnd(pos,1),GetOperandValue(pos,1),R0,R1,R2,R3,R4,R5,R6,R7,R8,R9,R10,R11,R12,R13,R14,R15,GBR,VBR,SR);
					if	(GetOpnd(pos,0) == "r0") R0 = BADADDR;
					else if (GetOpnd(pos,0) == "r1") R1 = BADADDR;
					else if (GetOpnd(pos,0) == "r2") R2 = BADADDR;
					else if (GetOpnd(pos,0) == "r3") R3 = BADADDR;
					else if (GetOpnd(pos,0) == "r4") R4 = BADADDR;
					else if (GetOpnd(pos,0) == "r5") R5 = BADADDR;
					else if (GetOpnd(pos,0) == "r6") R6 = BADADDR;
					else if (GetOpnd(pos,0) == "r7") R7 = BADADDR;
					else if (GetOpnd(pos,0) == "r8") R8 = BADADDR;
					else if (GetOpnd(pos,0) == "r9") R9 = BADADDR;
					else if (GetOpnd(pos,0) == "r10") R10 = BADADDR;
					else if (GetOpnd(pos,0) == "r11") R11 = BADADDR;
					else if (GetOpnd(pos,0) == "r12") R12 = BADADDR;
					else if (GetOpnd(pos,0) == "r13") R13 = BADADDR;
					else if (GetOpnd(pos,0) == "r14") R14 = BADADDR;
					else if (GetOpnd(pos,0) == "r15") R15 = BADADDR;
					if (ddst != BADADDR && !(GetFlags(pos) & FF_COMM)) { 
						modified = 1;						
						if (Name(ddst & 0xFFFFFFFF) == "") MakeComm(pos,"0x" + ltoa(ddst & 0xFFFFFFFF,16));
						else MakeComm(pos,Name(ddst & 0xFFFFFFFF));
						add_dref(pos,ddst & 0xFFFFFFFF,dr_I);
					}
				} else if ((GetOpType(pos,0) == o_displ || GetOpType(pos,0) == o_phrase) && GetOpType(pos,1) == o_reg ) {
					ddst = renesas_sh_decode_displ(GetOpnd(pos,0),GetOperandValue(pos,0),R0,R1,R2,R3,R4,R5,R6,R7,R8,R9,R10,R11,R12,R13,R14,R15,GBR,VBR,SR);
					if	(GetOpnd(pos,1) == "r0") R0 = BADADDR;
					else if (GetOpnd(pos,1) == "r1") R1 = BADADDR;
					else if (GetOpnd(pos,1) == "r2") R2 = BADADDR;
					else if (GetOpnd(pos,1) == "r3") R3 = BADADDR;
					else if (GetOpnd(pos,1) == "r4") R4 = BADADDR;
					else if (GetOpnd(pos,1) == "r5") R5 = BADADDR;
					else if (GetOpnd(pos,1) == "r6") R6 = BADADDR;
					else if (GetOpnd(pos,1) == "r7") R7 = BADADDR;
					else if (GetOpnd(pos,1) == "r8") R8 = BADADDR;
					else if (GetOpnd(pos,1) == "r9") R9 = BADADDR;
					else if (GetOpnd(pos,1) == "r10") R10 = BADADDR;
					else if (GetOpnd(pos,1) == "r11") R11 = BADADDR;
					else if (GetOpnd(pos,1) == "r12") R12 = BADADDR;
					else if (GetOpnd(pos,1) == "r13") R13 = BADADDR;
					else if (GetOpnd(pos,1) == "r14") R14 = BADADDR;
					else if (GetOpnd(pos,1) == "r15") R15 = BADADDR;
					if (ddst != BADADDR && !(GetFlags(pos) & FF_COMM)) { 
						modified = 1;
						if (Name(ddst & 0xFFFFFFFF) == "") MakeComm(pos,"0x" + ltoa(ddst & 0xFFFFFFFF,16));
						else MakeComm(pos,Name(ddst & 0xFFFFFFFF));
						add_dref(pos,ddst & 0xFFFFFFFF,dr_I);
					}
				} else {
					if	(GetOpnd(pos,1) == "r0") R0 = BADADDR;
					else if (GetOpnd(pos,1) == "r1") R1 = BADADDR;
					else if (GetOpnd(pos,1) == "r2") R2 = BADADDR;
					else if (GetOpnd(pos,1) == "r3") R3 = BADADDR;
					else if (GetOpnd(pos,1) == "r4") R4 = BADADDR;
					else if (GetOpnd(pos,1) == "r5") R5 = BADADDR;
					else if (GetOpnd(pos,1) == "r6") R6 = BADADDR;
					else if (GetOpnd(pos,1) == "r7") R7 = BADADDR;
					else if (GetOpnd(pos,1) == "r8") R8 = BADADDR;
					else if (GetOpnd(pos,1) == "r9") R9 = BADADDR;
					else if (GetOpnd(pos,1) == "r10") R10 = BADADDR;
					else if (GetOpnd(pos,1) == "r11") R11 = BADADDR;
					else if (GetOpnd(pos,1) == "r12") R12 = BADADDR;
					else if (GetOpnd(pos,1) == "r13") R13 = BADADDR;
					else if (GetOpnd(pos,1) == "r14") R14 = BADADDR;
					else if (GetOpnd(pos,1) == "r15") R15 = BADADDR;
				}
			} else if (mnem == "add") {
				if (GetOpType(pos,0) == o_imm && GetOpType(pos,1) == o_reg) {
					if	(GetOpnd(pos,1) == "r0" && R0 != BADADDR) R0 = R0 + GetOperandValue(pos,0);
					else if (GetOpnd(pos,1) == "r1" && R1 != BADADDR) R1 = R1 + GetOperandValue(pos,0);
					else if (GetOpnd(pos,1) == "r2" && R2 != BADADDR) R2 = R2 + GetOperandValue(pos,0);
					else if (GetOpnd(pos,1) == "r3" && R3 != BADADDR) R3 = R3 + GetOperandValue(pos,0);
					else if (GetOpnd(pos,1) == "r4" && R4 != BADADDR) R4 = R4 + GetOperandValue(pos,0);
					else if (GetOpnd(pos,1) == "r5" && R5 != BADADDR) R5 = R5 + GetOperandValue(pos,0);
					else if (GetOpnd(pos,1) == "r6" && R6 != BADADDR) R6 = R6 + GetOperandValue(pos,0);
					else if (GetOpnd(pos,1) == "r7" && R7 != BADADDR) R7 = R7 + GetOperandValue(pos,0);
					else if (GetOpnd(pos,1) == "r8" && R8 != BADADDR) R8 = R8 + GetOperandValue(pos,0);
					else if (GetOpnd(pos,1) == "r9" && R9 != BADADDR) R9 = R9 + GetOperandValue(pos,0);
					else if (GetOpnd(pos,1) == "r10" && R10 != BADADDR) R10 = R10 + GetOperandValue(pos,0);
					else if (GetOpnd(pos,1) == "r11" && R11 != BADADDR) R11 = R11 + GetOperandValue(pos,0);
					else if (GetOpnd(pos,1) == "r12" && R12 != BADADDR) R12 = R12 + GetOperandValue(pos,0);
					else if (GetOpnd(pos,1) == "r13" && R13 != BADADDR) R13 = R13 + GetOperandValue(pos,0);
					else if (GetOpnd(pos,1) == "r14" && R14 != BADADDR) R14 = R14 + GetOperandValue(pos,0);
					else if (GetOpnd(pos,1) == "r15" && R15 != BADADDR) R15 = R15 + GetOperandValue(pos,0);
				} else if (GetOpType(pos,0) == o_reg && GetOpType(pos,1) == o_reg) {
					if	(GetOpnd(pos,0) == "r0") opnd = R0;
					else if (GetOpnd(pos,0) == "r1") opnd = R1;
					else if (GetOpnd(pos,0) == "r2") opnd = R2;
					else if (GetOpnd(pos,0) == "r3") opnd = R3;
					else if (GetOpnd(pos,0) == "r4") opnd = R4;
					else if (GetOpnd(pos,0) == "r5") opnd = R5;
					else if (GetOpnd(pos,0) == "r6") opnd = R6;
					else if (GetOpnd(pos,0) == "r7") opnd = R7;
					else if (GetOpnd(pos,0) == "r8") opnd = R8;
					else if (GetOpnd(pos,0) == "r9") opnd = R9;
					else if (GetOpnd(pos,0) == "r10") opnd = R10;
					else if (GetOpnd(pos,0) == "r11") opnd = R11;
					else if (GetOpnd(pos,0) == "r12") opnd = R12;
					else if (GetOpnd(pos,0) == "r13") opnd = R13;
					else if (GetOpnd(pos,0) == "r14") opnd = R14;
					else if (GetOpnd(pos,0) == "r15") opnd = R15;
					if	(GetOpnd(pos,1) == "r0" && R0 != BADADDR) if (opnd != BADADDR) R0 = R0 + opnd; else R0 = BADADDR;
					else if (GetOpnd(pos,1) == "r1" && R1 != BADADDR) if (opnd != BADADDR) R1 = R1 + opnd; else R1 = BADADDR;
					else if (GetOpnd(pos,1) == "r2" && R2 != BADADDR) if (opnd != BADADDR) R2 = R2 + opnd; else R2 = BADADDR;
					else if (GetOpnd(pos,1) == "r3" && R3 != BADADDR) if (opnd != BADADDR) R3 = R3 + opnd; else R3 = BADADDR;
					else if (GetOpnd(pos,1) == "r4" && R4 != BADADDR) if (opnd != BADADDR) R4 = R4 + opnd; else R4 = BADADDR;
					else if (GetOpnd(pos,1) == "r5" && R5 != BADADDR) if (opnd != BADADDR) R5 = R5 + opnd; else R5 = BADADDR;
					else if (GetOpnd(pos,1) == "r6" && R6 != BADADDR) if (opnd != BADADDR) R6 = R6 + opnd; else R6 = BADADDR;
					else if (GetOpnd(pos,1) == "r7" && R7 != BADADDR) if (opnd != BADADDR) R7 = R7 + opnd; else R7 = BADADDR;
					else if (GetOpnd(pos,1) == "r8" && R8 != BADADDR) if (opnd != BADADDR) R8 = R8 + opnd; else R8 = BADADDR;
					else if (GetOpnd(pos,1) == "r9" && R9 != BADADDR) if (opnd != BADADDR) R9 = R9 + opnd; else R9 = BADADDR;
					else if (GetOpnd(pos,1) == "r10" && R10 != BADADDR) if (opnd != BADADDR) R10 = R10 + opnd; else R10 = BADADDR;
					else if (GetOpnd(pos,1) == "r11" && R11 != BADADDR) if (opnd != BADADDR) R11 = R11 + opnd; else R11 = BADADDR;
					else if (GetOpnd(pos,1) == "r12" && R12 != BADADDR) if (opnd != BADADDR) R12 = R12 + opnd; else R12 = BADADDR;
					else if (GetOpnd(pos,1) == "r13" && R13 != BADADDR) if (opnd != BADADDR) R13 = R13 + opnd; else R13 = BADADDR;
					else if (GetOpnd(pos,1) == "r14" && R14 != BADADDR) if (opnd != BADADDR) R14 = R14 + opnd; else R14 = BADADDR;
					else if (GetOpnd(pos,1) == "r15" && R15 != BADADDR) if (opnd != BADADDR) R15 = R15 + opnd; else R15 = BADADDR;
					else {
						if	(GetOpnd(pos,1) == "r0") R0 = BADADDR;
						else if (GetOpnd(pos,1) == "r1") R1 = BADADDR;
						else if (GetOpnd(pos,1) == "r2") R2 = BADADDR;
						else if (GetOpnd(pos,1) == "r3") R3 = BADADDR;
						else if (GetOpnd(pos,1) == "r4") R4 = BADADDR;
						else if (GetOpnd(pos,1) == "r5") R5 = BADADDR;
						else if (GetOpnd(pos,1) == "r6") R6 = BADADDR;
						else if (GetOpnd(pos,1) == "r7") R7 = BADADDR;
						else if (GetOpnd(pos,1) == "r8") R8 = BADADDR;
						else if (GetOpnd(pos,1) == "r9") R9 = BADADDR;
						else if (GetOpnd(pos,1) == "r10") R10 = BADADDR;
						else if (GetOpnd(pos,1) == "r11") R11 = BADADDR;
						else if (GetOpnd(pos,1) == "r12") R12 = BADADDR;
						else if (GetOpnd(pos,1) == "r13") R13 = BADADDR;
						else if (GetOpnd(pos,1) == "r14") R14 = BADADDR;
						else if (GetOpnd(pos,1) == "r15") R15 = BADADDR;
					}
				}
			} else if (mnem == "rts" || mnem == "rte" || mnem == "rtv/n" || mnem == "bra") {
				R0 = BADADDR;
				R1 = BADADDR;
				R2 = BADADDR;
				R3 = BADADDR;
				R4 = BADADDR;
				R5 = BADADDR;
				R6 = BADADDR;
				R7 = BADADDR;
				R8 = BADADDR;
				R9 = BADADDR;
				R10 = BADADDR;
				R11 = BADADDR;
				R12 = BADADDR;
				R13 = BADADDR;
				R14 = BADADDR;
				R15 = BADADDR;
				GBR = BADADDR;
				VBR = BADADDR;
				SR = BADADDR;
			} else if (mnem == "shll16" && GetOpType(pos,0) == o_reg) {
				if	(GetOpnd(pos,0) == "r0") R0 = R0 << 16;
				else if (GetOpnd(pos,0) == "r1") R1 = R1 << 16;
				else if (GetOpnd(pos,0) == "r2") R2 = R2 << 16;
				else if (GetOpnd(pos,0) == "r3") R3 = R3 << 16;
				else if (GetOpnd(pos,0) == "r4") R4 = R4 << 16;
				else if (GetOpnd(pos,0) == "r5") R5 = R5 << 16;
				else if (GetOpnd(pos,0) == "r6") R6 = R6 << 16;
				else if (GetOpnd(pos,0) == "r7") R7 = R7 << 16;
				else if (GetOpnd(pos,0) == "r8") R8 = R8 << 16;
				else if (GetOpnd(pos,0) == "r9") R9 = R9 << 16;
				else if (GetOpnd(pos,0) == "r10") R10 = R10 << 16;
				else if (GetOpnd(pos,0) == "r11") R11 = R11 << 16;
				else if (GetOpnd(pos,0) == "r12") R12 = R12 << 16;
				else if (GetOpnd(pos,0) == "r13") R13 = R13 << 16;
				else if (GetOpnd(pos,0) == "r14") R14 = R14 << 16;
				else if (GetOpnd(pos,0) == "r15") R15 = R15 << 16;
			} else if (mnem == "shll8" && GetOpType(pos,0) == o_reg) {
				if	(GetOpnd(pos,0) == "r0") R0 = R0 << 8;
				else if (GetOpnd(pos,0) == "r1") R1 = R1 << 8;
				else if (GetOpnd(pos,0) == "r2") R2 = R2 << 8;
				else if (GetOpnd(pos,0) == "r3") R3 = R3 << 8;
				else if (GetOpnd(pos,0) == "r4") R4 = R4 << 8;
				else if (GetOpnd(pos,0) == "r5") R5 = R5 << 8;
				else if (GetOpnd(pos,0) == "r6") R6 = R6 << 8;
				else if (GetOpnd(pos,0) == "r7") R7 = R7 << 8;
				else if (GetOpnd(pos,0) == "r8") R8 = R8 << 8;
				else if (GetOpnd(pos,0) == "r9") R9 = R9 << 8;
				else if (GetOpnd(pos,0) == "r10") R10 = R10 << 8;
				else if (GetOpnd(pos,0) == "r11") R11 = R11 << 8;
				else if (GetOpnd(pos,0) == "r12") R12 = R12 << 8;
				else if (GetOpnd(pos,0) == "r13") R13 = R13 << 8;
				else if (GetOpnd(pos,0) == "r14") R14 = R14 << 8;
				else if (GetOpnd(pos,0) == "r15") R15 = R15 << 8;
			} else if (mnem == "shll2" && GetOpType(pos,0) == o_reg) {
				if	(GetOpnd(pos,0) == "r0") R0 = R0 << 2;
				else if (GetOpnd(pos,0) == "r1") R1 = R1 << 2;
				else if (GetOpnd(pos,0) == "r2") R2 = R2 << 2;
				else if (GetOpnd(pos,0) == "r3") R3 = R3 << 2;
				else if (GetOpnd(pos,0) == "r4") R4 = R4 << 2;
				else if (GetOpnd(pos,0) == "r5") R5 = R5 << 2;
				else if (GetOpnd(pos,0) == "r6") R6 = R6 << 2;
				else if (GetOpnd(pos,0) == "r7") R7 = R7 << 2;
				else if (GetOpnd(pos,0) == "r8") R8 = R8 << 2;
				else if (GetOpnd(pos,0) == "r9") R9 = R9 << 2;
				else if (GetOpnd(pos,0) == "r10") R10 = R10 << 2;
				else if (GetOpnd(pos,0) == "r11") R11 = R11 << 2;
				else if (GetOpnd(pos,0) == "r12") R12 = R12 << 2;
				else if (GetOpnd(pos,0) == "r13") R13 = R13 << 2;
				else if (GetOpnd(pos,0) == "r14") R14 = R14 << 2;
				else if (GetOpnd(pos,0) == "r15") R15 = R15 << 2;
			} else if (mnem == "shll" && GetOpType(pos,0) == o_reg) {
				if	(GetOpnd(pos,0) == "r0") R0 = R0 << 1;
				else if (GetOpnd(pos,0) == "r1") R1 = R1 << 1;
				else if (GetOpnd(pos,0) == "r2") R2 = R2 << 1;
				else if (GetOpnd(pos,0) == "r3") R3 = R3 << 1;
				else if (GetOpnd(pos,0) == "r4") R4 = R4 << 1;
				else if (GetOpnd(pos,0) == "r5") R5 = R5 << 1;
				else if (GetOpnd(pos,0) == "r6") R6 = R6 << 1;
				else if (GetOpnd(pos,0) == "r7") R7 = R7 << 1;
				else if (GetOpnd(pos,0) == "r8") R8 = R8 << 1;
				else if (GetOpnd(pos,0) == "r9") R9 = R9 << 1;
				else if (GetOpnd(pos,0) == "r10") R10 = R10 << 1;
				else if (GetOpnd(pos,0) == "r11") R11 = R11 << 1;
				else if (GetOpnd(pos,0) == "r12") R12 = R12 << 1;
				else if (GetOpnd(pos,0) == "r13") R13 = R13 << 1;
				else if (GetOpnd(pos,0) == "r14") R14 = R14 << 1;
				else if (GetOpnd(pos,0) == "r15") R15 = R15 << 1;
			} else if ((mnem == "jsr" || mnem == "jsr/n" || mnem == "jmp") && GetOpType(pos,0) == o_phrase) {
				if	(GetOpnd(pos,0) == "@r0") jdst = R0;
				else if (GetOpnd(pos,0) == "@r1") jdst = R1;
				else if (GetOpnd(pos,0) == "@r2") jdst = R2;
				else if (GetOpnd(pos,0) == "@r3") jdst = R3;
				else if (GetOpnd(pos,0) == "@r4") jdst = R4;
				else if (GetOpnd(pos,0) == "@r5") jdst = R5;
				else if (GetOpnd(pos,0) == "@r6") jdst = R6;
				else if (GetOpnd(pos,0) == "@r7") jdst = R7;
				else if (GetOpnd(pos,0) == "@r8") jdst = R8;
				else if (GetOpnd(pos,0) == "@r9") jdst = R9;
				else if (GetOpnd(pos,0) == "@r10") jdst = R10;
				else if (GetOpnd(pos,0) == "@r11") jdst = R11;
				else if (GetOpnd(pos,0) == "@r12") jdst = R12;
				else if (GetOpnd(pos,0) == "@r13") jdst = R13;
				else if (GetOpnd(pos,0) == "@r14") jdst = R14;
				else if (GetOpnd(pos,0) == "@r15") jdst = R15;
				else jdst = BADADDR;
				if (jdst != BADADDR && !(GetFlags(pos) & FF_COMM)) {
					modified = 1;
					AddCodeXref(pos,jdst,1);
					MakeCode(jdst);
					Wait();
					Jump(pos);
					if (Name(jdst) == "") MakeComm(pos,"#unk_" + ltoa(jdst & 0xFFFFFFFF,16));
					else MakeComm(pos,Name(jdst));
				}
			}
		}
	} while (modified == 1);
}

""")
idc.eval_idc("renesas_sh_dynamic_xrefs();")